#import <Cocoa/Cocoa.h>
#import <SecurityFoundation/SFAuthorization.h>

@interface ARSecurity : NSObject

// returns null if not authorised
+ (NSData *) authoriseAndGetExternal:(NSString *) user password:(NSString*) password;

+ (BOOL) externalAuthIsValid:(NSData *) authData;

// these throw exceptions?!
+ (AuthorizationRef) authoriseForLogin:(NSString *) user password:(NSString*) password;
+ (AuthorizationRef) authoriseForLoginWithCStrings:(const char *) user password:(const char *) password;
+ (AuthorizationRef) readAuthentication:(NSFileHandle *) inp;
+ (AuthorizationRef) readAuthentication;
+ (void) writeAuthentication:(AuthorizationRef) ref output:(NSFileHandle*) output;

@end
