#import <Foundation/Foundation.h>

typedef void (^BasicBlock)(void);
typedef void (^OneArgBlock)(id);
typedef void (^StringArgBlock)(NSString*);
typedef void (^IntArgBlock)(int);
typedef void (^FloatArgBlock)(float);
typedef NSData* (^NSDataReturningBlock)(void);

NSThread *RunInBackground(BasicBlock block);
void RunOnMainThread(BOOL wait, BasicBlock block);
void RunOnMainThreadDeferred(BasicBlock block);
void RunOnThread(NSThread *thread, BOOL wait, BasicBlock block);
void RunAfterDelay(NSTimeInterval delay, BasicBlock block);
void WithAutoreleasePool(BasicBlock block);


@interface NSRunLoop (BlockAdditions)
- (void) perform:(BasicBlock) block;
@end