#import <Cocoa/Cocoa.h>
#import <IOKit/IOTypes.h>

#define WillSleepNotification @"ARWillSleep"
#define DidWakeNotification @"ARDidWake"

@interface SleepNotifier : NSObject {
	NSDate *lastWokeAt;
	BOOL sendSleepNotifications;
	BOOL sendWakeNotifications;
	BOOL notQuiteAwake;
	io_object_t powerConnection;
}

// Both off by default - the class is useful for the lastWokeAt property.
// Need to look into sleep delays if enabling sleep notifications.
@property (assign) BOOL sendWakeNotifications;
@property (assign) BOOL sendSleepNotifications;

// Check notQuiteAwake too.
@property (retain) NSDate *lastWokeAt;

// Been to sleep but haven't received the wake notification yet.
// This means that lastWokeAt won't be set yet.
@property (assign) BOOL notQuiteAwake;

// It's a singleton
+ (SleepNotifier*) instance;

// Call this to make it go! Note it needs to be on a run loop thread.
- (void) start;

// so we can get the constants nicely from Java
+ (NSString*) willSleepNotification;
+ (NSString*) didWakeNotification;

@end
