/*
 Methods for working with user accounts. Important to abstract this away from CBIdentity and CSIdentity* as these don't work properly in Lion's first release (specifically, finding a user by full name doesn't work).
 
 Note the explicit distinction between posix name (ie. short login name) and "any" name, which could be a full name.
 */
@interface UserUtil : NSObject

+ (NSString*) currentUserPosixName;

+ (NSString*) loggedInUserPosixName;

+ (NSString*) posixNameForAnyName:(NSString*) name;

+ (NSString*) fullNameForAnyName:(NSString*) name;

+ (NSString*) emailAddressForAnyName:(NSString*) name;

+ (BOOL) isGuestUserPosixName:(NSString*) user;

@end
