
@interface Volumes : NSObject

/*
 Returns the mount point of the volume with the given url, or nil if it's not mounted BY THIS USER.
 */
+ (NSString*) mountPointOfVolumeWithUrl:(NSURL*) url;

/*
 URLs of the volume mounted at path; particularly useful for network volumes
 */
+ (NSURL*) urlOfVolumeAtPath:(NSString*) path;


+ (NSArray*) mountPointsOfMountedVolumes;
+ (NSArray*) mountPointsOfMountedLocalVolumes;

/*
 Array of string paths of mount points of all mounted volumes the current user has access to
 */
+ (NSArray*) urlsOfMountedVolumes;

+ (FSVolumeRefNum) volumeRefNumOfVolumeAtPath:(NSString*) path;

@end
