#!/bin/sh

set -x

function collect {
	[ ! -d "$2" ] && mkdir "$2"
	for f in $1; do
		echo $f
	done \
	| tail -5 \
	| while read f; do
		[[ -e "$f" ]] && cp "$f" "$2"
	done
}


tmp=/tmp/FSContactSupport.$$
zip=/tmp/FSContactSupport.$$.zip
echo $zip
mkdir $tmp

exec 2> $tmp/stderr.txt

# We do this first, that way the daemon's diagnostics wont get cut off because we're too soon
system_profiler > $tmp/system_profiler.txt

collect ~/Library/Logs/CrashReporter/FarSuite_* $tmp/usercrash
collect ~/Library/Logs/CrashReporter/FarSuiteDaemon_\* $tmp/usercrash
collect ~/Library/Logs/CrashReporter/FarFinderAgent_\* $tmp/usercrash
collect ~/Library/Logs/CrashReporter/WebjimboAgent_\* $tmp/usercrash
collect ~/Library/Logs/CrashReporter/MobileDevice/\*/Presence_\* $tmp/iphonecrash

collect /Library/Logs/CrashReporter/FarSuite_\* $tmp/crash
collect /Library/Logs/CrashReporter/FarSuiteDaemon_\* $tmp/crash
collect /Library/Logs/CrashReporter/FarFinderAgent_\* $tmp/crash
collect /Library/Logs/CrashReporter/WebjimboAgent_\* $tmp/crash

cp -R /Library/Logs/FarSuite/* $tmp
cp -R "/Library/Application Support/FlyingMac/Licences" $tmp

mkdir $tmp/userprefs
cp ~/Library/Preferences/com.flyingmac.* $tmp/userprefs

cp -R /Library/FarSuite/files $tmp

cp ~/Library/Logs/FarSuiteInstaller.log $tmp

{
	date
	sw_vers
	echo -- set --
	set
	echo -- env --
	env
	echo -- id --
	id
	echo -- ps --
	ps axj
	echo ---- /Library/LaunchDaemons ----
	ls -l /Library/LaunchDaemons
	echo ---- /Library/LaunchAgents ----
	ls -l /Library/LaunchAgents
	echo ---- /Library/Preferences ----
	ls -l /Library/Preferences
	echo ---- /Library/FarSuite ----
	ls -lR /Library/FarSuite
	echo ---- /Library/Application Support/FlyingMac ----
	ls -lR "/Library/Application Support/FlyingMac"
} > $tmp/info.txt

cd $tmp
zip -r $zip .
cd -
rm -rf $tmp
