//
// Mac only, not iPhone!
//

#import <Foundation/Foundation.h>
#import <AppKit/AppKit.h>


@interface NSWindow (AppKitAdditions)

- (void) replaceContentView:(NSView*) viewToDisplay;
- (void) positionTopRight;
- (void) fadeIn;

@end


#pragma mark -------------------------------------------------------------------------------------------------------------------

@interface NSView (AppKitAdditions)

- (BOOL) contains:(NSEvent *) ev;

// WebViews are incompatible with Core Animation - they just go blank. Call this to find out whether you should
// enable CA on a view by calling setWantsLayer.
- (BOOL) canUseCoreAnimation;

// just use setFrameOrigin?
- (void) setLocation:(float) x y:(float) y;

- (NSPoint) convertToScreen:(NSPoint) p;

- (void) dump;
- (void) dump:(NSString*) prefix;
@end

#pragma mark -------------------------------------------------------------------------------------------------------------------

@interface NSObject (AppKitAdditions)

- (void) bind:(NSString*) binding like:(NSObject*) other;
- (void) bind:(NSString*) binding like:(NSString*) like of:(NSObject*) other;

@end

#pragma mark -------------------------------------------------------------------------------------------------------------------

@interface NumberEqualsTransformer : NSValueTransformer {
	int number;
}
@property (assign) int number;
@end

@interface NumberNotEqualsTransformer : NSValueTransformer {
	int number;
}
@property (assign) int number;
@end

#pragma mark -------------------------------------------------------------------------------------------------------------------

@interface TwoObjectsTransformer : NSValueTransformer {
	NSObject *forTrue;
	NSObject *forFalse;
}
- initWithTrueValue:(id) tv falseValue:(id) fv;
@property (retain) NSObject *forFalse;
@property (retain) NSObject *forTrue;
@end

#pragma mark -------------------------------------------------------------------------------------------------------------------

@interface NSWorkspace (AppKitAdditions)

- (void) composeEmailTo:(NSString*) to subject:(NSString*) subject body:(NSString*) body;

@end

#pragma mark -------------------------------------------------------------------------------------------------------------------

@interface NSApplication (AppKitAdditions)
@property (readonly) NSString *name;
@end
