#import <Cocoa/Cocoa.h>

/*
 Decorate a view that contains one subview at a time - it's used to switch from one view to another.
 
 The window size is adjusted according to the difference in size between the old and new views.
 Autosizing in IB should be set appropriately for this view, ie. tick everything. (This will make this view change its size to that
 of the subview, and keep an appropriate position.)
 Subviews should have the left and bottom autosize handles selected.
 Window resizing is animated.
 */
@interface NSView (SingleViewContainer)

+ (void) animateSingleViewContainerChanges:(BOOL) a;

- (void) setSingleViewAndResizeWindow:(NSView*) v;

- (void) setSingleView:(NSView*) view;

@end
