#import "miniwget.h"
#import "miniupnpc.h"
#import "upnpcommands.h"
#import "upnperrors.h"

/**
 Nice interface to the miniupnp library.
 
 Note: it uses the one included with TCMPortMapper. I tried changing it to the latest one from the actual miniupnp
 release, but port mappings were failing!
 
 Wonder why.
 
 Note that on 2010/04/12 there was a fix added to miniupnp for some Linksys routers (and possibly others).
 We won't have this change.
 */
@interface UpnpMini : NSObject {
	NSString *lastError;
	BOOL found;
	NSString *localIpForMapping;
	NSString *routerExternalIp;
	NSString *routerPrivateIp;
	struct UPNPUrls _urls;
	struct IGDdatas _igddata;
	BOOL preferAirportInterface;
	NSMutableString *mlog;
	BOOL tryOtherExternalPorts;
	int lastMappingErrorCode;
	NSString *routerName;
}
@property (retain) NSString *routerName;
@property (assign) int lastMappingErrorCode;
@property (assign) BOOL tryOtherExternalPorts;
@property (readonly) NSString *log;
@property (retain) NSString *routerPrivateIp;
@property (assign) BOOL preferAirportInterface;
@property (retain) NSString *lastError;
@property (retain) NSString *localIpForMapping;
@property (retain) NSString *routerExternalIp;
@property (assign) BOOL found;

// Returns the actual external port used in the mapping, or 0 if mapping fails.
- (int) map:(int) localPort externalPort:(int) externalPort protocol:(int)protocol mappingDescription:(NSString*) mappingDescription;

- (void) unmap:(int) externalPort protocol:(int)protocol;

@end
