on stdDate(_date)
	set {year:y, month:m, day:d} to _date
	set h to (time of _date) div 3600
	set min to (time of _date) mod 3600 div 60
	((y * 10000 + m * 100 + d) as string) & " " & h & ":" & min
end stdDate


on getItem(_id)
    tell application "Yojimbo"
        set _item to first database item whose id is _id
        set _copy to properties of _item & { tagNames: name of tags of _item }

        -- If it's an encrypted note and we don't have permission the contents will simply be blank. Fetch it
        -- explicitly, see if we get an error and set it to null if we do.
        if class of _item as text is "note item" and encrypted of _item
            try
                set contents of _copy to contents of contents of _item
            on error
                set contents of _copy to null
            end try
        end if

        -- Take the same approach for passwords
        if class of _item as text is "password item"
            try
                set password of _copy to password of _item
            on error
                set password of _copy to null
            end try
        end if

        return _copy & { modificationDate: my stdDate(modification date of _copy) }
    end tell
end getItem


on run _clargs

    tell application "Yojimbo"
        if (count of _clargs) = 0 then
            set argv to []
        else
            set _argsPath to item 1 of _clargs
            set _argsFile to posix file _argsPath as alias

            -- reading an empty file causes an error!
            set _size to size of (info for _argsFile)
            if _size = 0 then
                set argv to [""]
            else
                set _raw to read _argsFile as class utf8
                set AppleScript's text item delimiters to {data utxt0000}
                set argv to _raw's text items
                set AppleScript's text item delimiters to {""}
            end if
        end if
    end tell

    #content

end run

